// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
#include <unistd.h>
#include <csignal>
#include <cstdlib>
#include <iostream>

void handler(int s){
    std::cerr<< "The test harness timed out. Signal = "
	     << s << std::endl;
    exit(1);
}

int main(int argc, char * argv[]) {
    if(argc != 3){
	std::cerr << argv[0] << " <time limit> <test harness>" << std::endl;
	exit(1);
    }

    unsigned t = atoi(argv[1]);

    if(getenv("SAS_TEST_TIMEOUT")){
	t = atoi(getenv("SAS_TEST_TIMEOUT"));
	std::cerr << "Message: test harness timeout set from environment."
		  << std::endl;
    }

    std::cerr << "Message: " << "will run " << argv[2]
	      << " for no longer than " << t << " seconds." << std::endl;

    signal(SIGALRM, handler);
    alarm(t);
    if(system(argv[2])){
 	std::cerr << "Error while running " << argv[2] << std::endl;
 	exit(1);
     }
}
